import json

from flask import Flask, render_template, session
from flask_restful import reqparse, Api
from flask import request, redirect
from flask_cors import CORS
import random
from variable_store import *
from flask_migrate import Migrate
from db import db,secret_key
from resources.playlist import Playlist
from resources.playlist import NextEntry
from resources.playlist import PlaylistEntry
from flask_script import Manager
from flask_migrate import Migrate, MigrateCommand
from checktype import *
from resources.accounts import Accounts,AccountsList
from resources.login import Login
from resources.status import Status
from resources.mode import Mode
from resources.intercalatedEntry import IntercalatedEntry
from resources.scripts import Scripts
from resources.setplaylist import setPlaylist


app = Flask(__name__)

SESSION_TYPE = 'filesystem'
app.config.from_object(__name__)

CORS(app, resources={r'/*': {'origins': '*'}})
app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite:///database/data.db'
app.config['SQLALCHEMY_TRACK_MODIFICATIONS'] = False

app.config['SECRET_KEY'] = secret_key



api = Api(app)
api.add_resource(Mode, '/mode')
api.add_resource(Playlist, '/playlist')
api.add_resource(PlaylistEntry, '/playlistEntry/<string:name>', '/playlistEntry')
api.add_resource(NextEntry, '/nextEntry')
api.add_resource(Status, '/status')
api.add_resource(IntercalatedEntry, '/intercalatedEntry')
api.add_resource(setPlaylist, '/setPlaylist')
api.add_resource(Scripts, '/script')

migrate = Migrate(app, db, directory='./database/migrations')
manager = Manager(app)
manager.add_command('db', MigrateCommand)
db.init_app(app)



@app.route('/')
def billboard():
    setVarFromFile('defaultTurn', True)
    setVarFromFile('forced_next', False)
    setVarFromFile('first', True)
    return render_template("billboard.html")

"""
@app.route('/status')
def get_status():
    getVarFromFile('status')
    if getVarFromFile('status'):
        return {'message': "online"}, 200
    else:
        return {'message': "stop"}, 200


@app.route('/restart', methods=['POST'])
def shutd():
    setVarFromFile('status',False)
    return {'message': "correct"}, 200

@app.route('/setNext', methods=['POST']) #@app.route('/next', methods=['POST'])
def setNext():
    setVarFromFile('forced_next', True)
    parser = reqparse.RequestParser()
    # define al input parameters need and its type
    parser.add_argument('name', type=str, required=True, help="Path  not valid: 'path' not provided")
    parser.add_argument('duration', nullable=True, help="duration  not valid: 'duration' not provided")
    dades = parser.parse_args()
    chck=checkType(dades['name'])
    duration = None
    if chck == 'notAcceptedType':
        return make_response(("El fitxer no es multimedia", 400))
    else:
        if dades['duration']:
            duration = dades['duration']
        else:
            duration = 6000 
    setVarFromFile('forced_next_metadata', {'path': "./static/" + dades['name'], 'duration': duration, 'type': chck})
    return {'message': "correct"}, 200


def get_from_database():
    coin_flip = random.randint(1, 2)
    if coin_flip is not 1:
        r = random.randint(1, 10)
        m = "./static/" + str(r) + ".mp4"
        t = "video"
    else:
        r = random.randint(1, 3)
        m = "./static/" + str(r) + ".jpg"
        t = "Image"
    dic = {'path': m, 'duration': 6000, 'type': t}
    return json.loads(json.dumps(dic))
"""
if __name__ == '__main__':
    setVarFromFile('status', True)
    manager.run()
    app.run(host="localhost", port=8000, debug=True)
    # app.run(port=8000, debug=True)
