from flask_restful import Resource
from flask_restful import reqparse

from models.playlist import PlaylistModel
from variable_store import setVarFromFile


class setPlaylist(Resource):
    # @auth.login_required()
    def post(self):
        parser = reqparse.RequestParser()
        # define al input parameters need and its type
        parser.add_argument('name', type=str, required=True, help="You must specify the name of the playlist")
        parser.add_argument('items', type=list, location='json',required=True, help="You must include some items")
        parser.add_argument('mode', type=str, required=True, help="You must specify the mode")
        parser.add_argument('inter', type=str, required=False, help="You must select ain interspersed file")
        dades = parser.parse_args()
        # setVarFromFile('first', True)
        setVarFromFile('mode', dades['mode'])
        print(dades['inter'])
        if len(dades['items']) > 0:
            PlaylistModel.delete_all_from_db()
        for i in dades['items']:
            # print(i)
            new_playlist = PlaylistModel(i['name'], i['type'], i['duration']*1000, i['priority'], i['path'])
            PlaylistModel.save_to_db(new_playlist)
        if dades['inter']:
            # Seleccionem el fitxer de la llista i el fem intercalat
            inter_file = PlaylistModel.find_by_name(dades['inter'])
            print(inter_file.name)
            # L'eliminem de la llista normal perquè no surti repetit a més de quan li toca
            PlaylistModel.delete_by_name(dades['inter'])

            setVarFromFile('intercalated_metadata',
                          {'path': "./static/" + inter_file.name, 'duration': inter_file.duration,
                           'type': inter_file.type})
        else:
            setVarFromFile('intercalated_metadata', {'path': "./static/default.mp4", 'duration': 0, 'type': 'video'})
        return {'message': "S'està reproduint la llista \"" + dades['name'] +
                " amb el mode " + dades['mode']}, 200
